// Slider.cpp : Defines the initialization routines for the DLL.
//


#include "stdafx.h"
#include "Slider.h"
#include "Slider1.h"
#include "lsapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CSliderApp

BEGIN_MESSAGE_MAP(CSliderApp, CWinApp)
	//{{AFX_MSG_MAP(CSliderApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderApp construction

CSliderApp::CSliderApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_fIsBoxed = FALSE;
	m_IniFile = _T("");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSliderApp object

CSliderApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSliderApp initialization

BOOL CSliderApp::InitInstance()
{
	// Init OLE 
	::OleInitialize(NULL);

	// Register all OLE server (factories) as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();

	// Create the slider ini name
	CString	cModuleName = _T("");
	CString buf			= _T("");

	int nPos			= 0;

	if(!GetModuleFileName(GetModuleHandle(0), cModuleName.GetBuffer(MAX_PATH), MAX_PATH))
		return FALSE;	

	cModuleName.ReleaseBuffer();

	// Trim out the path
	nPos = cModuleName.ReverseFind('\\');

	if(-1 != nPos)
		nPos ++;

	m_IniFile = cModuleName.Left(nPos) + "lslnkmenu.ini";

	return TRUE;
}

int CSliderApp::ExitInstance() 
{
//	::OleUninitialize();
	
	return CWinApp::ExitInstance();
}

int CSliderApp::CreateSliders(HWND hParent)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

//	AfxOleInit();


	// Get the path to the ini file

	CString buffer = _T("");

	if(GetRCString("LsLnkMenuControlFile", buffer.GetBuffer(MAX_PATH), "", MAX_PATH))
	{
		buffer.ReleaseBuffer();

		if(buffer.GetLength())
			// Assign the string
			m_IniFile = buffer;
	}
	else
		buffer.ReleaseBuffer();

	CString cErrorText = _T("");

	HWND hDestopHWND = ::FindWindow("DesktopBackgroundClass", NULL);

	HWND hWndToUse = IsWindow(hDestopHWND) ? hDestopHWND : hParent;
	
	// Create the sliders
	int nNumberSliders = GetPrivateProfileInt("Main", "NumberOfSliders", 0, m_IniFile);
	
	if(nNumberSliders < 1)
	{
		cErrorText.Format("NumberOfSliders is either blank or 0 in INI file - %s", m_IniFile);

		ErrorLog(cErrorText);
		
		return 1;
	}

	for(int i = 0; i < nNumberSliders; i++)
	{
		CSlider* pSlider = new CSlider;

		if(NULL != pSlider)
		{
			if(pSlider->CreateSlider(i + 1, hWndToUse))
				m_colSliders.Add(pSlider);
		}
	}

	AddBangs();

	return m_colSliders.GetSize() == 0;		// return 0 for success
}

void CSliderApp::AddBangs()
{
	/*
	// Type definitions for pointer to AddBangCommand
	typedef BOOL (_cdecl *ADDBANGCOMMAND)(char*, void*);

	ADDBANGCOMMAND fpnAddBangCommand = NULL;

	fpnAddBangCommand = (ADDBANGCOMMAND)GetProcAddress(GetModuleHandle("LSAPI.DLL"), "AddBangCommand");
	

	if(fpnAddBangCommand)
	*/
	{
		AddBangCommand("!LSLNKREFRESH",	OnResetPanel);		
		AddBangCommand("!LSLNKEXECUTE",	OnExecute);
		AddBangCommand("!LSLNKHIDE",		OnHide);		
		AddBangCommand("!LSLNKTOGGLETOP",OnToggleTopMost);
		AddBangCommand("!LSLNKSHOW",		OnShow);
		AddBangCommand("!LSLNKMOVE",		OnMove);
		AddBangCommand("!LSLNKTOGGLE",	OnToggle);
		AddBangCommand("!LSLNKSHOWMENU",	OnShowMenu);
		AddBangCommand("!LSLNKCLOSEALL", OnCloseAll);
		AddBangCommand("!LSLNKBOXHOOK", OnBoxHook);
	}	
}

void CSliderApp::RemoveBangs()
{
	RemoveBangCommand("!LSLNKREFRESH");
	RemoveBangCommand("!LSLNKEXECUTE");
	RemoveBangCommand("!LSLNKHIDE");
	RemoveBangCommand("!LSLNKTOGGLETOP");
	RemoveBangCommand("!LSLNKSHOW");
	RemoveBangCommand("!LSLNKMOVE");
	RemoveBangCommand("!LSLNKTOGGLE");
	RemoveBangCommand("!LSLNKSHOWMENU");
	RemoveBangCommand("!LSLNKCLOSEALL");
	RemoveBangCommand("!LSLNKBOXHOOK");

}

void OnResetPanel(HWND caller, const char* arg)
{
	// This is the Entry point for the command. Its is called
	// from LiteStep. We pass on the theApp

	theApp.ResetPanel(caller, arg);
}

void CSliderApp::ResetPanel(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Called to reset 1 or all panels
	CString cArg = arg;

	if(cArg.GetLength())
	{
		int nPanelNumber = 0;

		// See its text
		if(isalpha(cArg.GetAt(0)))
			nPanelNumber = GetSliderFromDescription(cArg);
		else
			nPanelNumber = atoi(cArg);

		// See if its -1 or 0 (ResetAll)
		if(nPanelNumber <= 0)
		{
			// All panels
			for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
			{
				((CSlider*)m_colSliders[i])->ResetPanel();
			}

		}
		else
		{
			// Specific Slider
			if(nPanelNumber > m_colSliders.GetSize())
				// Too big, bail
				return;

			else
				// Specific Panel
				((CSlider*)m_colSliders[nPanelNumber - 1])->ResetPanel();
		}
	}
	else
	{
		// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			((CSlider*)m_colSliders[i])->ResetPanel();
		}
	}
}

void OnExecute(HWND caller, const char* arg)
{
	// Called from LS in Response to the LsLnkExecute bang
	theApp.Execute(caller, arg);
}

void CSliderApp::Execute(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString cArg			= arg;
	CString cSliderNumber	= _T("");
	CString cBtnNumber		= _T("");

	int nSliderNumber		= 0;
	int nBtnNumber			= 0;

	// Get the Slider Number (1st arg)
	int nPos = cArg.Find(" ", 0);
	
	if(-1 == nPos)
	{
		// Not enough params
		return;
	}
	
	cSliderNumber = cArg.Left(nPos);

	// See if this is Slider description instead of number
	if(isalpha(cSliderNumber.GetAt(0)))
		nSliderNumber = GetSliderFromDescription(cSliderNumber);
	else
		nSliderNumber = atoi(cSliderNumber);

	if(nSliderNumber <= 0 || nSliderNumber > m_colSliders.GetSize())
		// Invalid, bail
		return;

	cBtnNumber = cArg.Mid(nPos + 1);
	
	// See if this alpha
	if(isalpha(cBtnNumber.GetAt(0)))
	{
		// Call it
		((CSlider*)m_colSliders[nSliderNumber - 1])->Execute(cBtnNumber);
	}
	else
	{
		nBtnNumber = atoi(cBtnNumber);
		
		// Call it
		((CSlider*)m_colSliders[nSliderNumber - 1])->Execute(nBtnNumber);	
	}
}

void OnToggleTopMost(HWND caller, const char* arg)
{
	// Call the app function
	theApp.ToggleTopMost(caller, arg);
}

void CSliderApp::ToggleTopMost(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Called to toggle topmost for all buttons or a particular button
	CString cArg = arg;

	CSlider* pButton = NULL;

	if(cArg.GetLength())
	{
		int nPanelNumber = 0;

		// See its text
		if(isalpha(cArg.GetAt(0)))
			nPanelNumber = GetSliderFromDescription(cArg);
		else
			nPanelNumber = atoi(cArg);

		// See if its -1 or 0 (ResetAll)
		if(nPanelNumber <= 0)
		{
			// All panels
			for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
			{
				pButton = (CSlider*)m_colSliders[i];

				if(pButton)
				{
					if(pButton->m_bTopMost)
					{
						::SetWindowPos(pButton->m_hWnd, HWND_BOTTOM, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
						pButton->m_bTopMost = FALSE;
					}
					else
					{
						::SetWindowPos(pButton->m_hWnd, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
						pButton->m_bTopMost = TRUE;
					}				
				}
			}

		}
		else
		{
			// Specific Slider
			if(nPanelNumber > m_colSliders.GetSize())
				// Too big, bail
				return;

			else
			{
				// Specific Panel
				pButton = (CSlider*)m_colSliders[nPanelNumber - 1];

				if(pButton)
				{
					if(pButton->m_bTopMost)
					{
						::SetWindowPos(pButton->m_hWnd, HWND_BOTTOM, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
						pButton->m_bTopMost = FALSE;
					}
					else
					{
						::SetWindowPos(pButton->m_hWnd, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
						pButton->m_bTopMost = TRUE;
					}				
				
				}
			}
		}
	}
	else
	{
		// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			pButton = (CSlider*)m_colSliders[i];

			if(pButton)
			{
				if(pButton->m_bTopMost)
				{
					::SetWindowPos(pButton->m_hWnd, HWND_BOTTOM, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
					pButton->m_bTopMost = FALSE;
				}
				else
				{
					::SetWindowPos(pButton->m_hWnd, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);
					pButton->m_bTopMost = TRUE;
				}				
		
			}
		}
	}
}

void OnHide(HWND caller, const char * arg)
{
	// Call the App function
	theApp.Hide(caller, arg);
}

void OnCloseAll(HWND caller, const char* arg)
{
	theApp.CloseAll(caller, arg);
}

void OnBoxHook(HWND caller, const char* arg)
{
	theApp.BoxHook(caller, arg);
}

void CSliderApp::BoxHook(HWND caller, const char * arg)
{
	CloseAll(caller, arg);

	CSlider * pSlider = NULL;

	char *handle = strrchr(arg,' ');
	if ( handle ) {
		HWND hParent = (HWND)atoi(handle+1);
		if ( hParent ) {
			for ( int i = m_colSliders.GetUpperBound(); i>=0; i--) {
				pSlider = (CSlider*)m_colSliders[i];
				
				pSlider->BoxIt( hParent);
				
				m_fIsBoxed = TRUE;
			}
		}
	}
}

void CSliderApp::CloseAll(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	CSlider * pSlider = NULL;

	for ( int i = m_colSliders.GetUpperBound(); i >=0 ; i-- ) {
		pSlider = (CSlider*)m_colSliders[i];

		if ( pSlider->IsExpanded() )
			pSlider->HideMenu();
	}

/*			// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			pButton = (CSlider*)m_colSliders[i];

			if(pButton)
				pButton->ShowWindow(SW_NORMAL);				
		}
*/
}

void CSliderApp::Hide(HWND caller, const char * arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Called to toggle topmost for all buttons or a particular button
	CString cArg = arg;

	CSlider* pButton = NULL;

	if(cArg.GetLength())
	{
		int nPanelNumber = 0;

		// See its text
		if(isalpha(cArg.GetAt(0)))
			nPanelNumber = GetSliderFromDescription(cArg);
		else
			nPanelNumber = atoi(cArg);

		// See if its -1 or 0 (ResetAll)
		if(nPanelNumber <= 0)
		{
			// All panels
			for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
			{
				pButton = (CSlider*)m_colSliders[i];

				if(pButton)
					pButton->ShowWindow(SW_HIDE);
			}

		}
		else
		{
			// Specific Slider
			if(nPanelNumber > m_colSliders.GetSize())
				// Too big, bail
				return;

			else
			{
				// Specific Panel
				pButton = (CSlider*)m_colSliders[nPanelNumber - 1];
				
				if(pButton)
					pButton->ShowWindow(SW_HIDE);
			}
		}
	}
	else
	{
		// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			pButton = (CSlider*)m_colSliders[i];

			if(pButton)
				pButton->ShowWindow(SW_HIDE);
		}
	}	
}

void OnShow(HWND caller, const char* arg)
{
	// Call the App function
	theApp.Show(caller, arg);
}

void CSliderApp::Show(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Called to toggle topmost for all buttons or a particular button
	CString cArg = arg;

	CSlider* pButton = NULL;

	if(cArg.GetLength())
	{
		int nPanelNumber = 0;

		// See its text
		if(isalpha(cArg.GetAt(0)))
			nPanelNumber = GetSliderFromDescription(cArg);
		else
			nPanelNumber = atoi(cArg);

		// See if its -1 or 0 (ResetAll)
		if(nPanelNumber <= 0)
		{
			// All panels
			for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
			{
				pButton = (CSlider*)m_colSliders[i];

				if(pButton)
					pButton->ShowWindow(SW_NORMAL);				
			}

		}
		else
		{
			// Specific Slider
			if(nPanelNumber > m_colSliders.GetSize())
				// Too big, bail
				return;

			else
			{
				// Specific Panel
				pButton = (CSlider*)m_colSliders[nPanelNumber - 1];

				if(pButton)
					pButton->ShowWindow(SW_NORMAL);				
			}
		}
	}
	else
	{
		// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			pButton = (CSlider*)m_colSliders[i];

			if(pButton)
				pButton->ShowWindow(SW_NORMAL);				
		}
	}	
}

void OnMove(HWND caller, const char* arg)
{
	// Call the App version
	theApp.Move(caller, arg);
}

void CSliderApp::Move(HWND caller, const char* arg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString cArg			= arg;
	CString cSliderNumber	= _T("");
	CString cTmp			= _T("");

	int nSliderNumber		= 0;
	int nXPos				= 0;
	int nYPos				= 0;

	CSlider* pButton		= NULL;

	// Get the Slider Number (1st arg)
	int nPos = cArg.Find(" ", 0);
	
	if(-1 == nPos)
	{
		// Not enough params
		return;
	}
	
	cSliderNumber = cArg.Left(nPos);

	// See if this is Slider description instead of number
	if(isalpha(cSliderNumber.GetAt(0)))
		nSliderNumber = GetSliderFromDescription(cSliderNumber);
	else
		nSliderNumber = atoi(cSliderNumber);

	if(nSliderNumber <= 0 || nSliderNumber > m_colSliders.GetSize())
		// Invalid, bail
		return;

	cTmp = cArg.Mid(nPos + 1);
	
	// Extract the corrdinates
	nPos = cTmp.Find(" ", 0);
	
	if(-1 == nPos)
	{
		// Not enough params
		return;
	}

	nXPos = atoi(cTmp.Left(nPos));
	nYPos = atoi(cTmp.Mid(nPos + 1));

	//Call it
	pButton = (CSlider*)m_colSliders[nSliderNumber - 1];
	
	if(pButton)
		pButton->Move(nXPos, nYPos);

}

void OnToggle(HWND caller, const char* arg)
{
	// Call the theApp version
	theApp.Toggle(caller, arg);
}

void CSliderApp::Toggle(HWND caller, const char* arg)
{
	// Called to toggle the button(s) from Hidden / Showed
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// Called to toggle topmost for all buttons or a particular button
	CString cArg = arg;

	CSlider* pButton = NULL;

	if(cArg.GetLength())
	{
		int nPanelNumber = 0;

		// See its text
		if(isalpha(cArg.GetAt(0)))
			nPanelNumber = GetSliderFromDescription(cArg);
		else
			nPanelNumber = atoi(cArg);

		// See if its -1 or 0 (ResetAll)
		if(nPanelNumber <= 0)
		{
			// All panels
			for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
			{
				pButton = (CSlider*)m_colSliders[i];

				if(pButton)
					if(pButton->IsWindowVisible())
						pButton->ShowWindow(SW_HIDE);
					else
						pButton->ShowWindow(SW_NORMAL);
			}

		}
		else
		{
			// Specific Slider
			if(nPanelNumber > m_colSliders.GetSize())
				// Too big, bail
				return;

			else
			{
				// Specific Panel
				pButton = (CSlider*)m_colSliders[nPanelNumber - 1];
				
				if(pButton)
					if(pButton->IsWindowVisible())
						pButton->ShowWindow(SW_HIDE);
					else
						pButton->ShowWindow(SW_NORMAL);
			}
		}
	}
	else
	{
		// All panels
		for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
		{
			pButton = (CSlider*)m_colSliders[i];

			if(pButton)
				if(pButton->IsWindowVisible())
					pButton->ShowWindow(SW_HIDE);
				else
					pButton->ShowWindow(SW_NORMAL);
		}
	}
}

void OnShowMenu(HWND caller, const char* arg)
{
	theApp.ShowMenu(caller, arg);
}

void CSliderApp::ShowMenu(HWND caller, const char* arg)
{
	// Called to show the menu for a given ID
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CString cArg			= arg;

	int nSliderNumber		= 0;

	CSlider* pButton		= NULL;

	// Get the Slider Number 
	if(!cArg.GetLength())
	{
		// Not enough params
		return;
	}
	
	// See if this is Slider description instead of number
	if(isalpha(cArg.GetAt(0)))
		nSliderNumber = GetSliderFromDescription(cArg);
	else
		nSliderNumber = atoi(cArg);

	if(nSliderNumber <= 0 || nSliderNumber > m_colSliders.GetSize())
		// Invalid, bail
		return;

	//Call it
	pButton = (CSlider*)m_colSliders[nSliderNumber - 1];
	
	if(pButton)
		pButton->ShowMenu();
}

int CSliderApp::GetSliderFromDescription(CString cDescription)
{
	CSlider* pButton = NULL;

	// Loop for the collection looking for the description
	for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
	{
		pButton = (CSlider*)m_colSliders[i];

		if(pButton)
		{
			if(0 == cDescription.CompareNoCase(pButton->m_cDescription))
				return i + 1;
		}
	}

	return -1;
}

void CSliderApp::QuitModule()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	this->RemoveBangs();


	// Remove and kill all the Sliders
	for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
	{
		((CSlider*)m_colSliders[i])->DestroyWindow();
		delete m_colSliders[i];
	}

	m_colSliders.RemoveAll();
}


/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers
// Exported functions

__declspec( dllexport ) int initWharfModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType *wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath)
{
	return theApp.CreateSliders(parent);
}

__declspec( dllexport ) void quitWharfModule(HINSTANCE dll)
{
	quitModule(dll);
}

__declspec( dllexport ) void quitModule(HINSTANCE dllInst)
{
	theApp.QuitModule();
}


/*
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllGetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllCanUnloadNow();
}

// by exporting DllRegisterServer, you can use regsvr.exe
STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	COleObjectFactory::UpdateRegistryAll();
	return S_OK;
}

*/