// Slider.h : main header file for the SLIDER DLL
//

/// CHANGE LOG ////////////////////////////////////////////////////////////////
//
// * UPDATED: 01/13/2002 - repugnant
//              Linking against lsapi.lib, so we don't have to get the
//              address on the fly.
// * UPDATED: 01/13/2002 - repugnant
//              Updated the !Bang handlers to the new spec. (const char*
//              instead of char*)
// * ADDED:   01/13/2002 - global.h/cpp - repugnant
//              Added the GetLSLnkImagePath(...) function to read paths
//              from the INI file that include LiteStep $evars$.
// * UPDATED: 01/14/2002 - global.cpp - repugnant
//              Changed the GetProfileStringValue function to expand evars.
// * UPDATED: 01/14/2002 - global.cpp - repugnant
//              Changed the GetProfileIntValue fucntion to expand evars.
// * ADDED:   01/16/2002 - slider1.h/cpp, slider.h/cpp, globals.cpp - repugnant
//              Added support for "!LsLnkCloseAll" to close any open slider.
// * ADDED:   01/16/2002 - toomanytolist.cpp - repugnant
//              Added "!LsLnkBoxHook"
// * UPDATED: 06/30/2002 - ilmcuts (Release - v1.75)
//				Now using lsapi's functions to load bitmaps.
//				Removed GetLSLnkImagePath since LoadLSImage takes care of that
//				Minor tweaks
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SLIDER_H__9FD194C8_DA8E_11D3_ABF3_C999E02C0710__INCLUDED_)
#define AFX_SLIDER_H__9FD194C8_DA8E_11D3_ABF3_C999E02C0710__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include <afxcoll.h>		// For our collections

#include "common.h"


// send by the child to tell us we are no longer expanded
#define WM_CHILD_CONTRACTED		WM_USER + 100
#define WM_RUNBANG				WM_USER + 1000

/////////////////////////////////////////////////////////////////////////////
// CSliderApp
// See Slider.cpp for the implementation of this class
//

// Bang Stuff ( Called from LiteStep)
void OnToggleTopMost(HWND caller, const char* arg);
void OnHide(HWND caller, const char* arg);
void OnResetPanel(HWND caller, const char* arg);
void OnExecute(HWND caller, const char* arg);
void OnShow(HWND caller, const char* arg);
void OnMove(HWND caller, const char* arg);
void OnToggle(HWND caller, const char* arg);
void OnShowMenu(HWND caller, const char* arg);
void OnCloseAll(HWND caller, const char* arg);
void OnBoxHook(HWND caller, const char* arg);

class CSliderApp : public CWinApp
{
public:
	void QuitModule();
	int CreateSliders(HWND hParent);
	CString m_IniFile;
	CSliderApp();

	void ResetPanel(HWND caller, const char* arg);
	void Execute(HWND caller, const char* arg);
	void ToggleTopMost(HWND caller, const char* arg);
	void Hide(HWND caller, const char* arg);
	void Show(HWND caller, const char* arg);
	void Move(HWND caller, const char* arg);
	void Toggle(HWND caller, const char* arg);
	void ShowMenu(HWND caller, const char* arg);
	void CloseAll(HWND caller, const char* arg);
	void BoxHook(HWND caller, const char * arg);
	BOOL IsBoxed() const { return m_fIsBoxed; }
	CObArray m_colSliders;


protected:
	BOOL m_fIsBoxed;
	void RemoveBangs();
	void AddBangs();
	int GetSliderFromDescription(CString cDescription);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSliderApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSliderApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()


};

// External Entry Points

#ifdef __cplusplus
extern "C" {
#endif
__declspec( dllexport ) int initWharfModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType *wd);
__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
__declspec( dllexport ) void quitWharfModule(HINSTANCE dll);
__declspec( dllexport ) void quitModule(HINSTANCE dllInst);

#ifdef __cplusplus
}
#endif
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SLIDER_H__9FD194C8_DA8E_11D3_ABF3_C999E02C0710__INCLUDED_)
