#if !defined(AFX_SLIDERCHILD_H__F9CCF3A2_D8BE_11D3_9C79_005004186C6A__INCLUDED_)
#define AFX_SLIDERCHILD_H__F9CCF3A2_D8BE_11D3_9C79_005004186C6A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SliderChild.h : header file
//

#include <afxcoll.h>
#include "SliderButton.h"
#include "Dib.h"

/////////////////////////////////////////////////////////////////////////////
// CSliderChild window

class CSliderChild : public CWnd
{
	DECLARE_DYNCREATE(CSliderChild);

// Construction
public:
	CSliderChild();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSliderChild)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL


// Implementation
public:
	void OnParentMove(HWND hParent);
	void Execute(int nButtonNbr);
	void Execute(CString cBtnDesctription);
	void ResetPanel();
	void Animate(int nStep);

	BOOL IsExpanded();
	BOOL CreateChildSlider(int nSliderNbr, HWND hParent);
	
	virtual ~CSliderChild();

	// Generated message map functions
protected:
	void CalcPosition(HWND hParent);
	void SlideLeft(int nStep);
	void SlideRight(int nStep);
	void ExpandFullUp();
	void ExpandFullDown();
	void FadeIn();
	void FoldIn();
	void FoldOut();
	void SlideRightAndUp(int nStep);
	void SlideDown(int nStep);
	void SlideUp(int nStep);
	void SlideRightAndDown(int nStep);
	void GenerateBackBuffer(CDC* pDestDC);

	virtual BOOL AssembleVerticalBitmap();
	virtual BOOL AssembleHorizontalBitmap();
	virtual BOOL LoadSettings(int nSliderNbr);

	BOOL m_bDrawTransparent;
	BOOL m_bPrintText;
	BOOL m_bUseSmallIcons;
	BOOL m_bPrintIcon;
	BOOL m_bDynamic;
	BOOL m_bMouseTracking;
	BOOL m_bExpanded;
	BOOL m_bUseToolTip;

	int  m_nCurBtn;
	int  m_nOldBtn;
	int  m_nStep;
	int	 m_nIconXAdj;
	int	 m_nIconYAdj;
	int	 m_nTextXAdj;
	int	 m_nTextYAdj;
	int	 m_nFontHeight;
	int	 m_nSlideDirection;
	int	 m_nOrientation;
	int	 m_nSliderNumber;
	int	 m_nTransparency;
	int  m_nTopBitmapHeight;

	// The Fade Stuff
	int	 m_nFadeStep;
	int	 m_nFadeDelay;

	CFont m_Font;
	CRect m_OrigRect;
	CBitmap m_Bitmap;
	CDib	m_dibScreen;
	CBitmap m_OverBitmap;
	CDC	  m_BackBuffer;

	COXToolTipCtrl	m_ToolTip;

	COLORREF m_clrFontColor;
	COLORREF m_clrFontHighliteColor;

	HRGN m_hRgn;

	CObArray m_colSliderButtons;

	CString		m_cTopBitmapPath;
	CString		m_cBottomBitmapPath;
	CString		m_cMiddleBitmapPath;
	CString		m_cFontText;
	CString		m_cPath;
	CString		m_MouseOverSound;
	CString		m_PressSound;
	CString		m_WildCardSearch;
	CString		m_cExclusionList;

	//{{AFX_MSG(CSliderChild)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	afx_msg LRESULT OnMouseLeave(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SLIDERCHILD_H__F9CCF3A2_D8BE_11D3_9C79_005004186C6A__INCLUDED_)
