// SliderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Slider.h"
#include "SliderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSliderApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderDlg dialog

CSliderDlg::CSliderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSliderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSliderDlg)
	m_IconPath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CSliderDlg::~CSliderDlg()
{
	// Remove all the sliders
	for(int i = m_colSliders.GetUpperBound(); i >= 0; i--)
	{
		delete m_colSliders[i];
	}

	m_colSliders.RemoveAll();

}
void CSliderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSliderDlg)
	DDX_Text(pDX, IDC_EDIT1, m_IconPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSliderDlg, CDialog)
	//{{AFX_MSG_MAP(CSliderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnGetIcon)
	ON_BN_CLICKED(IDC_BUTTON3, OnLoadLnkFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSliderDlg message handlers

BOOL CSliderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	// Initialize OLE libraries
	if (!AfxOleInit())
	{	
		return FALSE;
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSliderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSliderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSliderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSliderDlg::OnButton1() 
{
	int nNumberSliders = GetPrivateProfileInt("Main", "NumberOfSliders", 0, theApp.m_IniFile);
	
	if(nNumberSliders < 1)
		return;

	for(int i = 0; i < nNumberSliders; i++)
	{
		CSlider* pSlider = new CSlider;

		if(NULL != pSlider)
		{
			pSlider->CreateSlider(i + 1, CWnd::GetDesktopWindow());

			m_colSliders.Add(pSlider);
		}
	}
}

void CSliderDlg::OnGetIcon() 
{
	CClientDC dc(this);

	UpdateData();

	HICON hIconBig	 = NULL;
	HICON hIconSmall = NULL;

	CString cPath = _T("");
	int nIndex = -99;

	WIN32_FIND_DATA  lpFindData;

	HANDLE hFindHandle = NULL;
	
	hFindHandle = FindFirstFile("D:\\launchkaos 2.1\\shortcuts\\Coding Stuff\\*.lnk", &lpFindData);

	do
	{
		cPath = _T("");
		nIndex = -99;

		if(INVALID_HANDLE_VALUE == hFindHandle)
			break;

		m_IconPath = "D:\\launchkaos 2.1\\shortcuts\\Coding Stuff\\";
		m_IconPath += lpFindData.cFileName;

		if(!GetLinkIcon(m_IconPath, cPath, nIndex))
			continue;

		ExtractIconEx(cPath, nIndex, &hIconBig, NULL, 1);
		ExtractIconEx(cPath, nIndex, NULL, &hIconSmall, 1);

		if(NULL == hIconBig)
			AfxMessageBox("No Big Icon");

		if(NULL == hIconSmall)
			AfxMessageBox("No small icon");

		if(NULL != hIconBig)
			DrawIconEx(dc.m_hDC, 83, 120, hIconBig, 32, 32, 0, NULL, DI_NORMAL);


		if(NULL != hIconSmall)
			DrawIconEx(dc.m_hDC, 130, 120, hIconSmall, 16, 16, 0, NULL, DI_NORMAL);
		
		DestroyIcon(hIconBig);
		DestroyIcon(hIconSmall);

		Sleep(1000);

		if(!FindNextFile(hFindHandle, &lpFindData))
			break;

	}while (1);

	FindClose(hFindHandle);
}


void CSliderDlg::OnLoadLnkFile() 
{
	CFileDialog dlg(TRUE, "Lnk Files", "", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
								"Link Files (*.lnk)|*.lnk|All Files (*.*)|*.*||", this);
 
	dlg.m_ofn.lpstrTitle = "Select a link";

	if (dlg.DoModal() == IDOK)
	{
		m_IconPath = dlg.GetFileName();
		UpdateData(FALSE);
	}	
}
